*** a/src/backend/access/heap/heapam.c
--- b/src/backend/access/heap/heapam.c
***************
*** 69,74 ****
--- 69,75 ----
  #include "utils/snapmgr.h"
  #include "utils/syscache.h"
  #include "utils/tqual.h"
+ #include "utils/sampleutils.h"
  
  
  /* GUC variable */
***************
*** 87,93 **** static XLogRecPtr log_heap_update(Relation reln, Buffer oldbuf,
  				bool all_visible_cleared, bool new_all_visible_cleared);
  static bool HeapSatisfiesHOTUpdate(Relation relation, Bitmapset *hot_attrs,
  					   HeapTuple oldtup, HeapTuple newtup);
! 
  
  /* ----------------------------------------------------------------
   *						 heap support routines
--- 88,96 ----
  				bool all_visible_cleared, bool new_all_visible_cleared);
  static bool HeapSatisfiesHOTUpdate(Relation relation, Bitmapset *hot_attrs,
  					   HeapTuple oldtup, HeapTuple newtup);
! static void acquire_next_sampletup(HeapScanDesc scan);
! static void acquire_block_sample(HeapScanDesc scan);
! static void	heapnullreturn(HeapScanDesc scan);
  
  /* ----------------------------------------------------------------
   *						 heap support routines
***************
*** 588,593 **** heapgettup(HeapScanDesc scan,
--- 591,599 ----
   *
   *		Same API as heapgettup, but used in page-at-a-time mode
   *
+  * SampleScan System algo is also implemented. Direction of Backward is especially used
+  * under CURSOR query.
+  *
   * The internal logic is much the same as heapgettup's too, but there are some
   * differences: we do not take the buffer content lock (that only needs to
   * happen inside heapgetpage), and we iterate through just the tuples listed
***************
*** 612,617 **** heapgettup_pagemode(HeapScanDesc scan,
--- 618,626 ----
  	OffsetNumber lineoff;
  	int			linesleft;
  	ItemId		lpp;
+ 	int			rand_percent;
+ 	int			sample_percent = scan->sample_percent;
+ 	void		*rand_state = scan->rs_randstate; /* random generator state */
  
  	/*
  	 * calculate next starting lineindex, given scan direction
***************
*** 630,635 **** heapgettup_pagemode(HeapScanDesc scan,
--- 639,664 ----
  				return;
  			}
  			page = scan->rs_startblock; /* first page */
+ 
+ 			/* SampleScan, implement SYSTEM page selection */
+ 			if(scan->is_sample_scan)
+ 			{
+ 				while(page < scan->rs_nblocks)
+ 				{
+ 					rand_percent = get_rand_in_range(rand_state, 0, 100);
+ 					if(rand_percent >= sample_percent)
+ 						page++;
+ 					else break;
+ 				}
+ 				finished = (page >= scan->rs_nblocks);
+ 				/* All pages just skiped, clear up and return */
+ 				if(finished)
+ 				{
+ 					heapnullreturn(scan);
+ 					return;
+ 				}
+ 			}
+ 
  			heapgetpage(scan, page);
  			lineindex = 0;
  			scan->rs_inited = true;
***************
*** 673,678 **** heapgettup_pagemode(HeapScanDesc scan,
--- 702,727 ----
  				page = scan->rs_startblock - 1;
  			else
  				page = scan->rs_nblocks - 1;
+ 
+ 			/* SampleScan, implement SYSTEM page selection */
+ 			if(scan->is_sample_scan)
+ 			{
+ 				while(page > 0)
+ 				{
+ 					rand_percent = get_rand_in_range(rand_state, 0, 100);
+ 					if(rand_percent >= sample_percent)
+ 						page--;
+ 					else break;
+ 				}
+ 				finished = (page == scan->rs_startblock);
+ 				/* All pages just skiped, clear up and return */
+ 				if(finished)
+ 				{
+ 					heapnullreturn(scan);
+ 					return;
+ 				}
+ 			}
+ 
  			heapgetpage(scan, page);
  		}
  		else
***************
*** 701,706 **** heapgettup_pagemode(HeapScanDesc scan,
--- 750,756 ----
  	{
  		/*
  		 * ``no movement'' scan direction: refetch prior tuple
+ 		 * Same behavior for SampleScan, so no change
  		 */
  		if (!scan->rs_inited)
  		{
***************
*** 782,797 **** heapgettup_pagemode(HeapScanDesc scan,
  		 */
  		if (backward)
  		{
  			finished = (page == scan->rs_startblock);
! 			if (page == 0)
  				page = scan->rs_nblocks;
  			page--;
  		}
  		else
  		{
  			page++;
  			if (page >= scan->rs_nblocks)
! 				page = 0;
  			finished = (page == scan->rs_startblock);
  
  			/*
--- 832,878 ----
  		 */
  		if (backward)
  		{
+ 			/* SampleScan, implement SYSTEM page selection */
+ 			if(scan->is_sample_scan)
+ 			{
+ 				while(page > scan->rs_startblock)
+ 				{
+ 					rand_percent = get_rand_in_range(rand_state, 0, 100);
+ 					if(rand_percent >= sample_percent)
+ 						page--;
+ 					else break;
+ 				}
+ 			}
+ 
  			finished = (page == scan->rs_startblock);
! 			/*
! 			 * It was deciding page == 0, now change to 
! 			 * page == scan->rs_startblock, otherwise doesn't make sense.
! 			 * Is this reasoning correct?
! 			 */
! 			if (page == scan->rs_startblock)
  				page = scan->rs_nblocks;
  			page--;
  		}
  		else
  		{
  			page++;
+ 
+ 			/* SampleScan, implement SYSTEM page selection */
+ 			while(page < scan->rs_nblocks)
+ 			{
+ 				rand_percent = get_rand_in_range(rand_state, 0, 100);
+ 				if(rand_percent >= sample_percent)
+ 					page++;
+ 				else break;
+ 			}
+ 			/*
+ 			 * It was setting page = 0, now change to 
+ 			 * page = scan->rs_startblock, otherwise doesn't make sense.
+ 			 * Is this reasoning correct?
+ 			 */
  			if (page >= scan->rs_nblocks)
! 				page = scan->rs_startblock;
  			finished = (page == scan->rs_startblock);
  
  			/*
***************
*** 815,826 **** heapgettup_pagemode(HeapScanDesc scan,
  		 */
  		if (finished)
  		{
! 			if (BufferIsValid(scan->rs_cbuf))
! 				ReleaseBuffer(scan->rs_cbuf);
! 			scan->rs_cbuf = InvalidBuffer;
! 			scan->rs_cblock = InvalidBlockNumber;
! 			tuple->t_data = NULL;
! 			scan->rs_inited = false;
  			return;
  		}
  
--- 896,902 ----
  		 */
  		if (finished)
  		{
! 			heapnullreturn(scan);
  			return;
  		}
  
***************
*** 836,841 **** heapgettup_pagemode(HeapScanDesc scan,
--- 912,930 ----
  	}
  }
  
+ static void
+ heapnullreturn(HeapScanDesc scan)
+ {
+ 	HeapTuple	tuple = &(scan->rs_ctup);
+ 
+ 	if (BufferIsValid(scan->rs_cbuf))
+ 		ReleaseBuffer(scan->rs_cbuf);
+ 	scan->rs_cbuf = InvalidBuffer;
+ 	scan->rs_cblock = InvalidBlockNumber;
+ 	tuple->t_data = NULL;
+ 	scan->rs_inited = false;
+ 	return;
+ }
  
  #if defined(DISABLE_COMPLEX_MACRO)
  /*
***************
*** 1236,1241 **** heap_beginscan_internal(Relation relation, Snapshot snapshot,
--- 1325,1333 ----
  
  	initscan(scan, key, false);
  
+ 	/* By default, it is not samplescan */
+ 	scan->is_sample_scan = false;
+ 
  	return scan;
  }
  
***************
*** 1315,1332 **** heap_endscan(HeapScanDesc scan)
  #endif   /* !defined(HEAPDEBUGALL) */
  
  
  HeapTuple
  heap_getnext(HeapScanDesc scan, ScanDirection direction)
  {
  	/* Note: no locking manipulations needed */
  
  	HEAPDEBUG_1;				/* heap_getnext( info ) */
  
! 	if (scan->rs_pageatatime)
! 		heapgettup_pagemode(scan, direction,
! 							scan->rs_nkeys, scan->rs_key);
! 	else
! 		heapgettup(scan, direction, scan->rs_nkeys, scan->rs_key);
  
  	if (scan->rs_ctup.t_data == NULL)
  	{
--- 1407,1446 ----
  #endif   /* !defined(HEAPDEBUGALL) */
  
  
+ /*
+  * SampleScan is implemented from this function.
+  */
  HeapTuple
  heap_getnext(HeapScanDesc scan, ScanDirection direction)
  {
  	/* Note: no locking manipulations needed */
  
+ 	TableSampleMethod sample_method = scan->sample_method;
+ 
  	HEAPDEBUG_1;				/* heap_getnext( info ) */
  
! 	/* if sample percent is 0, just return NULL */
! 	if (scan->is_sample_scan && scan->sample_percent == 0)
! 		return NULL;
! 
! 	/* SampleScan or SeqScan */
! 	if (scan->is_sample_scan)
! 	{
! 		/* Which sample method */
! 		if(sample_method == SAMPLE_SYSTEM)
! 			/* This function will check scan type inside */
! 			heapgettup_pagemode(scan, direction,
! 								scan->rs_nkeys, scan->rs_key);
! 		else if(sample_method == SAMPLE_BERNOULLI)
! 			acquire_next_sampletup(scan);
! 	} else 
! 	{
! 		if (scan->rs_pageatatime)
! 			heapgettup_pagemode(scan, direction,
! 								scan->rs_nkeys, scan->rs_key);
! 		else
! 			heapgettup(scan, direction, scan->rs_nkeys, scan->rs_key);
! 	}
  
  	if (scan->rs_ctup.t_data == NULL)
  	{
***************
*** 5780,5782 **** heap_sync(Relation rel)
--- 5894,6071 ----
  		heap_close(toastrel, AccessShareLock);
  	}
  }
+ 
+ /*
+  * acquire_next_sampletup -- algo modified from acquire_sample_rows in analyze.c.
+  * The core algo is inside acquire_block_sample.
+  */
+ static void
+ acquire_next_sampletup(HeapScanDesc scan)
+ {
+ 	HeapTuple		tuple = &(scan->rs_ctup);
+ 	HeapTuple		pass_tuple;
+ 
+ 	/* Collect the sample first if not yet */
+ 	if(!scan->rs_sampleinited)
+ 		acquire_block_sample(scan);
+ 
+ 	/* Just retrieve tuple one by one from the sample collection */
+ 	if(scan->rs_curindex < scan->rs_samplesize)
+ 	{
+ 		/* Get the head tuple from sampled tuple array */
+ 		pass_tuple = scan->rs_samplerows[scan->rs_curindex];
+ 		tuple->t_len = pass_tuple->t_len;
+ 		tuple->t_self = pass_tuple->t_self;
+ 		tuple->t_tableOid = pass_tuple->t_tableOid;
+ 		tuple->t_data = pass_tuple->t_data;
+ 		scan->rs_curindex++;
+ 	}
+ 	else
+ 	{
+ 		/* No more tuple to return */
+ 		scan->rs_cbuf = InvalidBuffer;
+ 		scan->rs_cblock = InvalidBlockNumber;
+ 		tuple->t_data = NULL;
+ 	}
+ 
+ 	return;
+ }
+ 
+ /*
+  * See acquire_sample_rows in analyze.c for detail description of the algo.
+  * Selected rows are returned in the caller-allocated array scan->rs_samplerows, which
+  * must have at least targrows entries.
+  *
+  */
+ static void
+ acquire_block_sample(HeapScanDesc scan)
+ {
+ 	int			numrows = 0;	/* # rows now in reservoir */
+ 	double		samplerows = 0; /* total # rows collected */
+ 	double		rowstoskip = -1;	/* -1 means not set yet */
+ 	int			targrows = scan->targrows;
+ 	HeapTuple	*rows = scan->rs_samplerows;
+ 	BlockNumber	totalblocks = scan->rs_nblocks;
+ 	BlockSamplerData bs;
+ 	Relation onerel = scan->rs_rd;
+ 	void	*rand_state = scan->rs_randstate;
+ 	double		rstate;
+ 
+ 	/* If the required sample size is 0, we just return */
+ 	if(targrows == 0)
+ 	{
+ 		scan->rs_samplesize = 0;
+ 		scan->rs_sampleinited = true;
+ 		return;
+ 	}
+ 
+ 	Assert(targrows > 0);
+ 
+ 	/* Prepare for sampling block numbers */
+ 	BlockSampler_Init(&bs, totalblocks, targrows);
+ 	/* Prepare for sampling rows */
+ 	rstate = anl_init_selection_state(rand_state, targrows);
+ 
+ 	/* Outer loop over blocks to sample */
+ 	while (BlockSampler_HasMore(&bs))
+ 	{
+ 		BlockNumber targblock = BlockSampler_Next(rand_state, &bs);
+ 		Buffer		targbuffer;
+ 		Page		targpage;
+ 		OffsetNumber targoffset,
+ 					maxoffset;
+ 
+ 		/*
+ 		 * We must maintain a pin on the target page's buffer to ensure that
+ 		 * the maxoffset value stays good (else concurrent VACUUM might delete
+ 		 * tuples out from under us).  Hence, pin the page until we are done
+ 		 * looking at it.  We also choose to hold sharelock on the buffer
+ 		 * throughout --- we could release and re-acquire sharelock for each
+ 		 * tuple, but since we aren't doing much work per tuple, the extra
+ 		 * lock traffic is probably better avoided.
+ 		 */
+ 		targbuffer = ReadBufferExtended(onerel, MAIN_FORKNUM, targblock,
+ 										RBM_NORMAL, scan->rs_strategy);
+ 		LockBuffer(targbuffer, BUFFER_LOCK_SHARE);
+ 		targpage = BufferGetPage(targbuffer);
+ 		maxoffset = PageGetMaxOffsetNumber(targpage);
+ 
+ 		/* Inner loop over all tuples on the selected page */
+ 		for (targoffset = FirstOffsetNumber; targoffset <= maxoffset; targoffset++)
+ 		{
+ 			ItemId		itemid;
+ 			HeapTupleData targtuple;
+ 
+ 			itemid = PageGetItemId(targpage, targoffset);
+ 
+ 			/*
+ 			 * We ignore unused and redirect line pointers.  DEAD line
+ 			 * pointers should be counted as dead, because we need vacuum to
+ 			 * run to get rid of them.	Note that this rule agrees with the
+ 			 * way that heap_page_prune() counts things.
+ 			 */
+ 			if (!ItemIdIsNormal(itemid))
+ 			{
+ 				continue;
+ 			}
+ 
+ 			ItemPointerSet(&targtuple.t_self, targblock, targoffset);
+ 
+ 			targtuple.t_data = (HeapTupleHeader) PageGetItem(targpage, itemid);
+ 			targtuple.t_len = ItemIdGetLength(itemid);
+ 
+ 			/*
+ 			 * The first targrows sample rows are simply copied into the
+ 			 * reservoir. Then we start replacing tuples in the sample
+ 			 * until we reach the end of the relation.	This algorithm is
+ 			 * from Jeff Vitter's paper (see full citation below). It
+ 			 * works by repeatedly computing the number of tuples to skip
+ 			 * before selecting a tuple, which replaces a randomly chosen
+ 			 * element of the reservoir (current set of tuples).  At all
+ 			 * times the reservoir is a true random sample of the tuples
+ 			 * we've passed over so far, so when we fall off the end of
+ 			 * the relation we're done.
+ 			 */
+ 			if (numrows < targrows)
+ 				rows[numrows++] = heap_copytuple(&targtuple);
+ 			else
+ 			{
+ 				/*
+ 				 * t in Vitter's paper is the number of records already
+ 				 * processed.  If we need to compute a new S value, we
+ 				 * must use the not-yet-incremented value of samplerows as
+ 				 * t.
+ 				 */
+ 				if (rowstoskip < 0)
+ 					rowstoskip = anl_get_next_S(rand_state, samplerows, targrows,
+ 												&rstate);
+ 
+ 				if (rowstoskip <= 0)
+ 				{
+ 					/*
+ 					 * Found a suitable tuple, so save it, replacing one
+ 					 * old tuple at random
+ 					 */
+ 					int			k = (int) (targrows * anl_random_fract(rand_state));
+ 
+ 					Assert(k >= 0 && k < targrows);
+ 					heap_freetuple(rows[k]);
+ 					rows[k] = heap_copytuple(&targtuple);
+ 				}
+ 
+ 				rowstoskip -= 1;
+ 			}
+ 
+ 			samplerows += 1;
+ 		}
+ 
+ 		/* Now release the lock and pin on the page */
+ 		UnlockReleaseBuffer(targbuffer);
+ 	}
+ 
+ 	scan->rs_samplesize = numrows;
+ 	scan->rs_sampleinited = true;
+ 
+ 	return;
+ }
+ 
*** a/src/backend/commands/analyze.c
--- b/src/backend/commands/analyze.c
***************
*** 52,70 ****
  #include "utils/syscache.h"
  #include "utils/timestamp.h"
  #include "utils/tqual.h"
  
  
- /* Data structure for Algorithm S from Knuth 3.4.2 */
- typedef struct
- {
- 	BlockNumber N;				/* number of blocks, known in advance */
- 	int			n;				/* desired sample size */
- 	BlockNumber t;				/* current block number */
- 	int			m;				/* blocks selected so far */
- } BlockSamplerData;
- 
- typedef BlockSamplerData *BlockSampler;
- 
  /* Per-index data for ANALYZE */
  typedef struct AnlIndexData
  {
--- 52,60 ----
  #include "utils/syscache.h"
  #include "utils/timestamp.h"
  #include "utils/tqual.h"
+ #include "utils/sampleutils.h"
  
  
  /* Per-index data for ANALYZE */
  typedef struct AnlIndexData
  {
***************
*** 86,95 **** static BufferAccessStrategy vac_strategy;
  static void do_analyze_rel(Relation onerel, VacuumStmt *vacstmt,
  			   AcquireSampleRowsFunc acquirefunc, BlockNumber relpages,
  			   bool inh, int elevel);
- static void BlockSampler_Init(BlockSampler bs, BlockNumber nblocks,
- 				  int samplesize);
- static bool BlockSampler_HasMore(BlockSampler bs);
- static BlockNumber BlockSampler_Next(BlockSampler bs);
  static void compute_index_stats(Relation onerel, double totalrows,
  					AnlIndexData *indexdata, int nindexes,
  					HeapTuple *rows, int numrows,
--- 76,81 ----
***************
*** 108,114 **** static void update_attstats(Oid relid, bool inh,
  static Datum std_fetch_func(VacAttrStatsP stats, int rownum, bool *isNull);
  static Datum ind_fetch_func(VacAttrStatsP stats, int rownum, bool *isNull);
  
- 
  /*
   *	analyze_rel() -- analyze one relation
   */
--- 94,99 ----
***************
*** 937,1030 **** examine_attribute(Relation onerel, int attnum, Node *index_expr)
  }
  
  /*
-  * BlockSampler_Init -- prepare for random sampling of blocknumbers
-  *
-  * BlockSampler is used for stage one of our new two-stage tuple
-  * sampling mechanism as discussed on pgsql-hackers 2004-04-02 (subject
-  * "Large DB").  It selects a random sample of samplesize blocks out of
-  * the nblocks blocks in the table.  If the table has less than
-  * samplesize blocks, all blocks are selected.
-  *
-  * Since we know the total number of blocks in advance, we can use the
-  * straightforward Algorithm S from Knuth 3.4.2, rather than Vitter's
-  * algorithm.
-  */
- static void
- BlockSampler_Init(BlockSampler bs, BlockNumber nblocks, int samplesize)
- {
- 	bs->N = nblocks;			/* measured table size */
- 
- 	/*
- 	 * If we decide to reduce samplesize for tables that have less or not much
- 	 * more than samplesize blocks, here is the place to do it.
- 	 */
- 	bs->n = samplesize;
- 	bs->t = 0;					/* blocks scanned so far */
- 	bs->m = 0;					/* blocks selected so far */
- }
- 
- static bool
- BlockSampler_HasMore(BlockSampler bs)
- {
- 	return (bs->t < bs->N) && (bs->m < bs->n);
- }
- 
- static BlockNumber
- BlockSampler_Next(BlockSampler bs)
- {
- 	BlockNumber K = bs->N - bs->t;		/* remaining blocks */
- 	int			k = bs->n - bs->m;		/* blocks still to sample */
- 	double		p;				/* probability to skip block */
- 	double		V;				/* random */
- 
- 	Assert(BlockSampler_HasMore(bs));	/* hence K > 0 and k > 0 */
- 
- 	if ((BlockNumber) k >= K)
- 	{
- 		/* need all the rest */
- 		bs->m++;
- 		return bs->t++;
- 	}
- 
- 	/*----------
- 	 * It is not obvious that this code matches Knuth's Algorithm S.
- 	 * Knuth says to skip the current block with probability 1 - k/K.
- 	 * If we are to skip, we should advance t (hence decrease K), and
- 	 * repeat the same probabilistic test for the next block.  The naive
- 	 * implementation thus requires an anl_random_fract() call for each block
- 	 * number.	But we can reduce this to one anl_random_fract() call per
- 	 * selected block, by noting that each time the while-test succeeds,
- 	 * we can reinterpret V as a uniform random number in the range 0 to p.
- 	 * Therefore, instead of choosing a new V, we just adjust p to be
- 	 * the appropriate fraction of its former value, and our next loop
- 	 * makes the appropriate probabilistic test.
- 	 *
- 	 * We have initially K > k > 0.  If the loop reduces K to equal k,
- 	 * the next while-test must fail since p will become exactly zero
- 	 * (we assume there will not be roundoff error in the division).
- 	 * (Note: Knuth suggests a "<=" loop condition, but we use "<" just
- 	 * to be doubly sure about roundoff error.)  Therefore K cannot become
- 	 * less than k, which means that we cannot fail to select enough blocks.
- 	 *----------
- 	 */
- 	V = anl_random_fract();
- 	p = 1.0 - (double) k / (double) K;
- 	while (V < p)
- 	{
- 		/* skip */
- 		bs->t++;
- 		K--;					/* keep K == N - t */
- 
- 		/* adjust p to be new cutoff point in reduced range */
- 		p *= 1.0 - (double) k / (double) K;
- 	}
- 
- 	/* select */
- 	bs->m++;
- 	return bs->t++;
- }
- 
- /*
   * acquire_sample_rows -- acquire a random sample of rows from the table
   *
   * Selected rows are returned in the caller-allocated array rows[], which
--- 922,927 ----
***************
*** 1082,1093 **** acquire_sample_rows(Relation onerel, int elevel,
  	/* Prepare for sampling block numbers */
  	BlockSampler_Init(&bs, totalblocks, targrows);
  	/* Prepare for sampling rows */
! 	rstate = anl_init_selection_state(targrows);
  
  	/* Outer loop over blocks to sample */
  	while (BlockSampler_HasMore(&bs))
  	{
! 		BlockNumber targblock = BlockSampler_Next(&bs);
  		Buffer		targbuffer;
  		Page		targpage;
  		OffsetNumber targoffset,
--- 979,990 ----
  	/* Prepare for sampling block numbers */
  	BlockSampler_Init(&bs, totalblocks, targrows);
  	/* Prepare for sampling rows */
! 	rstate = anl_init_selection_state(NULL, targrows);
  
  	/* Outer loop over blocks to sample */
  	while (BlockSampler_HasMore(&bs))
  	{
! 		BlockNumber targblock = BlockSampler_Next(NULL, &bs);
  		Buffer		targbuffer;
  		Page		targpage;
  		OffsetNumber targoffset,
***************
*** 1229,1235 **** acquire_sample_rows(Relation onerel, int elevel,
  					 * t.
  					 */
  					if (rowstoskip < 0)
! 						rowstoskip = anl_get_next_S(samplerows, targrows,
  													&rstate);
  
  					if (rowstoskip <= 0)
--- 1126,1132 ----
  					 * t.
  					 */
  					if (rowstoskip < 0)
! 						rowstoskip = anl_get_next_S(NULL, samplerows, targrows,
  													&rstate);
  
  					if (rowstoskip <= 0)
***************
*** 1238,1244 **** acquire_sample_rows(Relation onerel, int elevel,
  						 * Found a suitable tuple, so save it, replacing one
  						 * old tuple at random
  						 */
! 						int			k = (int) (targrows * anl_random_fract());
  
  						Assert(k >= 0 && k < targrows);
  						heap_freetuple(rows[k]);
--- 1135,1141 ----
  						 * Found a suitable tuple, so save it, replacing one
  						 * old tuple at random
  						 */
! 						int			k = (int) (targrows * anl_random_fract(NULL));
  
  						Assert(k >= 0 && k < targrows);
  						heap_freetuple(rows[k]);
***************
*** 1297,1412 **** acquire_sample_rows(Relation onerel, int elevel,
  	return numrows;
  }
  
- /* Select a random value R uniformly distributed in (0 - 1) */
- double
- anl_random_fract(void)
- {
- 	return ((double) random() + 1) / ((double) MAX_RANDOM_VALUE + 2);
- }
- 
- /*
-  * These two routines embody Algorithm Z from "Random sampling with a
-  * reservoir" by Jeffrey S. Vitter, in ACM Trans. Math. Softw. 11, 1
-  * (Mar. 1985), Pages 37-57.  Vitter describes his algorithm in terms
-  * of the count S of records to skip before processing another record.
-  * It is computed primarily based on t, the number of records already read.
-  * The only extra state needed between calls is W, a random state variable.
-  *
-  * anl_init_selection_state computes the initial W value.
-  *
-  * Given that we've already read t records (t >= n), anl_get_next_S
-  * determines the number of records to skip before the next record is
-  * processed.
-  */
- double
- anl_init_selection_state(int n)
- {
- 	/* Initial value of W (for use when Algorithm Z is first applied) */
- 	return exp(-log(anl_random_fract()) / n);
- }
- 
- double
- anl_get_next_S(double t, int n, double *stateptr)
- {
- 	double		S;
- 
- 	/* The magic constant here is T from Vitter's paper */
- 	if (t <= (22.0 * n))
- 	{
- 		/* Process records using Algorithm X until t is large enough */
- 		double		V,
- 					quot;
- 
- 		V = anl_random_fract(); /* Generate V */
- 		S = 0;
- 		t += 1;
- 		/* Note: "num" in Vitter's code is always equal to t - n */
- 		quot = (t - (double) n) / t;
- 		/* Find min S satisfying (4.1) */
- 		while (quot > V)
- 		{
- 			S += 1;
- 			t += 1;
- 			quot *= (t - (double) n) / t;
- 		}
- 	}
- 	else
- 	{
- 		/* Now apply Algorithm Z */
- 		double		W = *stateptr;
- 		double		term = t - (double) n + 1;
- 
- 		for (;;)
- 		{
- 			double		numer,
- 						numer_lim,
- 						denom;
- 			double		U,
- 						X,
- 						lhs,
- 						rhs,
- 						y,
- 						tmp;
- 
- 			/* Generate U and X */
- 			U = anl_random_fract();
- 			X = t * (W - 1.0);
- 			S = floor(X);		/* S is tentatively set to floor(X) */
- 			/* Test if U <= h(S)/cg(X) in the manner of (6.3) */
- 			tmp = (t + 1) / term;
- 			lhs = exp(log(((U * tmp * tmp) * (term + S)) / (t + X)) / n);
- 			rhs = (((t + X) / (term + S)) * term) / t;
- 			if (lhs <= rhs)
- 			{
- 				W = rhs / lhs;
- 				break;
- 			}
- 			/* Test if U <= f(S)/cg(X) */
- 			y = (((U * (t + 1)) / term) * (t + S + 1)) / (t + X);
- 			if ((double) n < S)
- 			{
- 				denom = t;
- 				numer_lim = term + S;
- 			}
- 			else
- 			{
- 				denom = t - (double) n + S;
- 				numer_lim = t + 1;
- 			}
- 			for (numer = t + S; numer >= numer_lim; numer -= 1)
- 			{
- 				y *= numer / denom;
- 				denom -= 1;
- 			}
- 			W = exp(-log(anl_random_fract()) / n);		/* Generate W in advance */
- 			if (exp(log(y) / n) <= (t + X) / t)
- 				break;
- 		}
- 		*stateptr = W;
- 	}
- 	return S;
- }
- 
  /*
   * qsort comparator for sorting rows[] array
   */
--- 1194,1199 ----
***************
*** 1431,1437 **** compare_rows(const void *a, const void *b)
  	return 0;
  }
  
- 
  /*
   * acquire_inherited_sample_rows -- acquire sample rows from inheritance tree
   *
--- 1218,1223 ----
*** a/src/backend/commands/explain.c
--- b/src/backend/commands/explain.c
***************
*** 725,730 **** ExplainNode(PlanState *planstate, List *ancestors,
--- 725,733 ----
  		case T_SeqScan:
  			pname = sname = "Seq Scan";
  			break;
+ 		case T_SampleScan:
+ 			pname = sname = "Sample Scan";
+ 			break;
  		case T_IndexScan:
  			pname = sname = "Index Scan";
  			break;
***************
*** 864,869 **** ExplainNode(PlanState *planstate, List *ancestors,
--- 867,873 ----
  	switch (nodeTag(plan))
  	{
  		case T_SeqScan:
+ 		case T_SampleScan:
  		case T_BitmapHeapScan:
  		case T_TidScan:
  		case T_SubqueryScan:
***************
*** 1109,1114 **** ExplainNode(PlanState *planstate, List *ancestors,
--- 1113,1119 ----
  										   planstate, es);
  			/* FALL THRU */
  		case T_SeqScan:
+ 		case T_SampleScan:
  		case T_ValuesScan:
  		case T_CteScan:
  		case T_WorkTableScan:
***************
*** 1819,1824 **** ExplainTargetRel(Plan *plan, Index rti, ExplainState *es)
--- 1824,1830 ----
  	switch (nodeTag(plan))
  	{
  		case T_SeqScan:
+ 		case T_SampleScan:
  		case T_IndexScan:
  		case T_IndexOnlyScan:
  		case T_BitmapHeapScan:
*** a/src/backend/executor/Makefile
--- b/src/backend/executor/Makefile
***************
*** 21,27 **** OBJS = execAmi.o execCurrent.o execGrouping.o execJunk.o execMain.o \
         nodeLimit.o nodeLockRows.o \
         nodeMaterial.o nodeMergeAppend.o nodeMergejoin.o nodeModifyTable.o \
         nodeNestloop.o nodeFunctionscan.o nodeRecursiveunion.o nodeResult.o \
!        nodeSeqscan.o nodeSetOp.o nodeSort.o nodeUnique.o \
         nodeValuesscan.o nodeCtescan.o nodeWorktablescan.o \
         nodeGroup.o nodeSubplan.o nodeSubqueryscan.o nodeTidscan.o \
         nodeForeignscan.o nodeWindowAgg.o tstoreReceiver.o spi.o
--- 21,27 ----
         nodeLimit.o nodeLockRows.o \
         nodeMaterial.o nodeMergeAppend.o nodeMergejoin.o nodeModifyTable.o \
         nodeNestloop.o nodeFunctionscan.o nodeRecursiveunion.o nodeResult.o \
!        nodeSeqscan.o nodeSamplescan.o nodeSetOp.o nodeSort.o nodeUnique.o \
         nodeValuesscan.o nodeCtescan.o nodeWorktablescan.o \
         nodeGroup.o nodeSubplan.o nodeSubqueryscan.o nodeTidscan.o \
         nodeForeignscan.o nodeWindowAgg.o tstoreReceiver.o spi.o
*** a/src/backend/executor/execAmi.c
--- b/src/backend/executor/execAmi.c
***************
*** 38,43 ****
--- 38,44 ----
  #include "executor/nodeRecursiveunion.h"
  #include "executor/nodeResult.h"
  #include "executor/nodeSeqscan.h"
+ #include "executor/nodeSamplescan.h"
  #include "executor/nodeSetOp.h"
  #include "executor/nodeSort.h"
  #include "executor/nodeSubplan.h"
***************
*** 152,157 **** ExecReScan(PlanState *node)
--- 153,162 ----
  			ExecReScanSeqScan((SeqScanState *) node);
  			break;
  
+ 		case T_SampleScanState:
+ 			ExecReScanSampleScan((SampleScanState *) node);
+ 			break;
+ 
  		case T_IndexScanState:
  			ExecReScanIndexScan((IndexScanState *) node);
  			break;
***************
*** 274,279 **** ExecMarkPos(PlanState *node)
--- 279,288 ----
  			ExecSeqMarkPos((SeqScanState *) node);
  			break;
  
+ 		case T_SampleScanState:
+ 			ExecSampleMarkPos((SampleScanState *) node);
+ 			break;
+ 
  		case T_IndexScanState:
  			ExecIndexMarkPos((IndexScanState *) node);
  			break;
***************
*** 331,336 **** ExecRestrPos(PlanState *node)
--- 340,349 ----
  			ExecSeqRestrPos((SeqScanState *) node);
  			break;
  
+ 		case T_SampleScanState:
+ 			ExecSampleRestrPos((SampleScanState *) node);
+ 			break;
+ 
  		case T_IndexScanState:
  			ExecIndexRestrPos((IndexScanState *) node);
  			break;
***************
*** 383,388 **** ExecSupportsMarkRestore(NodeTag plantype)
--- 396,402 ----
  	switch (plantype)
  	{
  		case T_SeqScan:
+ 		case T_SampleScan:
  		case T_IndexScan:
  		case T_IndexOnlyScan:
  		case T_TidScan:
***************
*** 452,457 **** ExecSupportsBackwardScan(Plan *node)
--- 466,475 ----
  		case T_CteScan:
  			return TargetListSupportsBackwardScan(node->targetlist);
  
+ 		/* For now, TableSample should not do backward */
+ 		case T_SampleScan:
+ 			return false;
+ 
  		case T_IndexScan:
  			return IndexSupportsBackwardScan(((IndexScan *) node)->indexid) &&
  				TargetListSupportsBackwardScan(node->targetlist);
*** a/src/backend/executor/execCurrent.c
--- b/src/backend/executor/execCurrent.c
***************
*** 261,266 **** search_plan_tree(PlanState *node, Oid table_oid)
--- 261,267 ----
  			 * scan nodes can all be treated alike
  			 */
  		case T_SeqScanState:
+ 		case T_SampleScanState:
  		case T_IndexScanState:
  		case T_IndexOnlyScanState:
  		case T_BitmapHeapScanState:
*** a/src/backend/executor/execProcnode.c
--- b/src/backend/executor/execProcnode.c
***************
*** 101,106 ****
--- 101,107 ----
  #include "executor/nodeRecursiveunion.h"
  #include "executor/nodeResult.h"
  #include "executor/nodeSeqscan.h"
+ #include "executor/nodeSamplescan.h"
  #include "executor/nodeSetOp.h"
  #include "executor/nodeSort.h"
  #include "executor/nodeSubplan.h"
***************
*** 188,193 **** ExecInitNode(Plan *node, EState *estate, int eflags)
--- 189,199 ----
  												   estate, eflags);
  			break;
  
+ 		case T_SampleScan:
+ 			result = (PlanState *) ExecInitSampleScan((SampleScan *) node,
+ 													   estate, eflags);
+ 			break;
+ 
  		case T_IndexScan:
  			result = (PlanState *) ExecInitIndexScan((IndexScan *) node,
  													 estate, eflags);
***************
*** 399,404 **** ExecProcNode(PlanState *node)
--- 405,414 ----
  			result = ExecSeqScan((SeqScanState *) node);
  			break;
  
+ 		case T_SampleScanState:
+ 			result = ExecSampleScan((SampleScanState *) node);
+ 			break;
+ 
  		case T_IndexScanState:
  			result = ExecIndexScan((IndexScanState *) node);
  			break;
***************
*** 633,638 **** ExecEndNode(PlanState *node)
--- 643,652 ----
  			ExecEndSeqScan((SeqScanState *) node);
  			break;
  
+ 		case T_SampleScanState:
+ 			ExecEndSampleScan((SampleScanState *) node);
+ 			break;
+ 
  		case T_IndexScanState:
  			ExecEndIndexScan((IndexScanState *) node);
  			break;
